import { default as record } from './record';
import { Replayer, playerConfig, PlayerMachineState, SpeedMachineState } from './replay';
import { default as canvasMutation } from './replay/canvas';
import { _mirror } from './utils';

import * as utils from './utils';
export { EventType, IncrementalSource, MouseInteractions, ReplayerEvents, type eventWithTime, } from '@luminai-platform/rrweb-types';
export type { recordOptions, ReplayPlugin } from './types';
declare const addCustomEvent: <T>(tag: string, payload: T) => void;
declare const freezePage: () => void;
declare const takeFullSnapshot: (isCheckout?: boolean | undefined) => void;
export { record, addCustomEvent, freezePage, takeFullSnapshot, Replayer, type playerConfig, type PlayerMachineState, type SpeedMachineState, canvasMutation, _mirror as mirror, utils, };
